# -*- python -*-
# $RCSfile: fontselector.py,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2005/08/09 13:51:18 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

import gtk

class FontSelector:
    OK = 1
    CANCEL = 2
    def __init__(self, parent=None):
        self.dialog = gtk.Dialog(title="OOF2 Font Selector", parent=parent)
        self.dialog.add_button("OK", self.OK)
        self.dialog.add_button("Cancel", self.CANCEL)
        self.fontselector = gtk.FontSelection()
        self.dialog.vbox.pack_start(self.fontselector, expand=1, fill=1)
    def run(self):
        self.dialog.show_all()
        return self.dialog.run()
    def close(self):
        self.dialog.destroy()
    def hide(self):
        self.dialog.hide()
    def get_font_name(self):
        return self.fontselector.get_font_name()

_fsdialog = None

def getFontName(parentwindow=None):
    global _fsdialog
    if not _fsdialog:
        _fsdialog = FontSelector(parentwindow)
    result = _fsdialog.run()
    if result in (FontSelector.CANCEL, gtk.RESPONSE_DELETE_EVENT,
                  gtk.RESPONSE_NONE):
        _fsdialog.hide()
        return None
    fname = _fsdialog.get_font_name()
    _fsdialog.hide()
    return fname
