# -*- python -*-
# $RCSfile: gtkutils.py,v $
# $Revision: 1.8 $
# $Author: langer $
# $Date: 2005/08/12 19:17:46 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

import gtk
import pango
from oof2.common import debug

## NOTE: The following function is commented out, because it doesn't
## work well.  There's no way in gtk2 to set the size of a widget
## except to call set_size_request, which sets the widget's minimum
## size.  This means that a window created with copyWidgetSizes won't
## be shrinkable.

# Make widget dest have the same size as widget source.  Since widgets
# get their sizes from their children, recursively set the children's
# sizes too.  This only works if both source and dest have the same
# structure, of course.  It's meant to be used when cloning windows.
# This doesn't work completely correctly.  Perhaps the allocation is
# not the right thing to be copying?

##def copyWidgetSizes(source, dest):
##    debug.mainthreadTest()
##    bbox = source.get_allocation()
##    dest.set_size_request(bbox.width, bbox.height)
##    if isinstance(source, gtk.Container) and isinstance(dest, gtk.Container):
##        for s,d in zip(source.get_children(), dest.get_children()):
##            copyWidgetSizes(s, d)



# Return the char and digit sizes for a widget's font.

def widgetFontSizes(widget):
    fontdesc = widget.get_style().font_desc
    fontcontext = widget.create_pango_context()
    font = fontcontext.load_font(fontdesc)
    fontmetrics = font.get_metrics(None)
    return (fontmetrics.get_approximate_char_width()/pango.SCALE,
            fontmetrics.get_approximate_digit_width()/pango.SCALE)

def widgetCharSize(widget):
    return widgetFontSizes(widget)[0]

def widgetDigitSize(widget):
    return widgetFontSizes(widget)[1]
