# -*- python -*-
# $RCSfile: brushstyle_.py,v $
# $Revision: 1.9 $
# $Author: langer $
# $Date: 2005/05/13 18:43:44 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from oof2.common import cregisteredclass
from oof2.common.IO import parameter
from oof2.common.IO import xmlmenudump

cregisteredclass.registerCClass(BrushStylePtr)
BrushStylePtr.tip = "Brush styles for pixel selection."
BrushStylePtr.discussion = """<para>
Objects of the <classname>BrushStyle</classname> are used as the
<varname>style</varname> parameter in the <xref
linkend='MenuItem:OOF.Graphics_n.Toolbox.Pixel_Select.Brush'/> command
for selecting pixels.
</para>"""

circleReg = cregisteredclass.Registration(
    "Circle",
    BrushStylePtr,
    CircleBrush,
    ordering=0,
    params=[parameter.FloatParameter('radius', 0,
                                     tip='Radius of the brush in physical units.')],
    tip="Brush with a circular profile.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/common/reg/circlebrush.xml')
    )

squareReg = cregisteredclass.Registration(
    "Square",
    BrushStylePtr,
    SquareBrush,
    ordering=1,
    params=[parameter.FloatParameter('size', 0,
                                     tip='Half the side of the brush in physical units.')],
    tip="Brush with a square profile.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/common/reg/squarebrush.xml')
    )
