// -*- C++ -*-
// $RCSfile: cdebug.h,v $
// $Revision: 1.7 $
// $Author: langer $
// $Date: 2005/06/08 18:28:10 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#ifndef CDEBUG_H
#define CDEBUG_H

// Routines used to catch C++ signals and dump the current Python
// stack before bailing out.

#include <Python.h>
#include <vector>

void initDebug(PyObject*);
void installSignals_();
void restoreSignals_();

void segfault(int);
void wait(int);
void throwException();
void throwPythonException();

#ifdef DEBUG
#define installSignals /*installSignals_()*/ // commented out for profiling
#define restoreSignals /*restoreSignals_()*/
#else
#define installSignals /**/
#define restoreSignals /**/
#endif

#endif // CDEBUG_H
