# -*- python -*-
# $RCSfile: mainthread.py,v $
# $Revision: 1.8 $
# $Author: langer $
# $Date: 2005/08/08 21:39:27 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.


# Stuff for identifying the main thread.  Because this file is
# imported and executed by the main thread at startup time,
# mainthreadNumber is initially the number of the initial thread.
# This can change if "rethread" gets called, which resets the "main"
# attributes to refer to whichever thread called rethread.

from oof2.SWIG.common.IO import threadstate

mainthreadNumber = threadstate.findThreadNumber()
mainthreadState = threadstate.findThreadState()

def mainthread():
    return threadstate.findThreadNumber() == mainthreadNumber

############

# Routines for submitting functions to be run in the main thread.

# When not in threaded graphics mode, both run and runBlock just
# execute the given function.  In threaded graphics mode, they execute
# the function on the main thread.  run doesn't wait for an answer, so
# it can't return a value.  runBlock does wait, so it does return a
# value.


def _run(func, args=(), kwargs={}):
    func(*args, **kwargs)

def _runBlock(func, args=(), kwargs={}):
    return func(*args, **kwargs)

# These variables get overwritten by mainthreadGUI, when it's imported.
run = _run

runBlock = _runBlock

# Utility function -- assigns the "main" thread to be whatever thread
# calls this function.  Used by the GUI when it starts, because the
# GUI thread needs to be main, even if it's not the originating
# thread.
def rethread():
    global mainthreadNumber
    global maindthreadState
    threadstate.make_thread_main()
    mainthreadNumber = threadstate.findThreadNumber()
    mainthreadState = threadstate.findThreadState()
    
    
