// -*- C++ -*-
// $RCSfile: oofcpp.C,v $
// $Revision: 1.2 $
// $Author: langer $
// $Date: 2005/04/29 18:14:44 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

// This mysterious file allows all of the separate SWIG generated
// *cmodule.C files to be linked together into one .so file, which can
// be loaded by Python.  If the separate .C files each created its own
// .so, then each would have undefined symbols, and Python couldn't
// load it.  But if we simply link all of the SWIG generated files
// into oofcppcmodule.so, Python still can't load it because the
// library doesn't have a function called 'initoofcppc()'.  This file
// remedies that deficiency.  Python requires that initoofcppc()
// creates a module named 'oofcppc'.  However, all of the real code is
// contained in other modules, which are created by the SWIG-generated
// init*c() functions in the *cmodule.C files.  So initoofcppc()
// creates an empty module, and runs all of the other init*c()
// functions to create the real modules.  Python then knows that
// these modules exist and have been loaded, and when they are
// subsequently imported, no disk access is required.  One peculiar
// result of this peculiar scheme is that because the real modules
// haven't been explicitly imported from a file, Python thinks they're
// built-in:
//      >>> import oofcppc
//      >>> import SRC.engine.node   # from SWIG generated Python file
//      >>> SRC.engine.node
//      <module 'SRC.engine.node' from 'SRC/engine/node.py'>
//      >>> import nodec             # from SWIG generated C++ file
//      >>> nodec
//      <module 'nodec' (built-in)>  # !!!
// This could be remedied by setting the __file__ attribute in each
// module, which is probably not worth the effort.

// At the time of writing, it is not known if this is a clever trick
// or a dangerous abuse of the system.

#include <Python.h>
static PyMethodDef funcs[] = {
  {NULL, NULL}
};

extern "C" {
  void initoofcppc() {
    // Create the dummy module.
    PyObject *m = Py_InitModule("oofcppc", funcs);

    // The full list of init*c() functions is created by the Makefile
    // (or setup.py) and included here.  The Makefile constructs the
    // function names from the names of all of the SWIG input files.
#include "oofcpp.h"
  }
}
