# -*- python -*-
# $RCSfile: interface_criteria.py,v $
# $Revision: 1.2 $
# $Author: redwing $
# $Date: 2005/07/28 20:59:04 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.common import registeredclass
from oof2.common.IO import parameter
from oof2.SWIG.common import devel
from oof2.SWIG.common.IO import progressbar
from oof2.SWIG.common import switchboard
from oof2.engine.IO import materialparameter

class Criteria (registeredclass.RegisteredClass):
    registry = []
    ## holds the common machinery for
    ## selecting elements, splitting nodes,
    ## and manipulating the mesh.
    ##
    ## subclasses have specific methods
    ## to select element pairs
    def __init__(self):
        pass
    def create_interface(elist, femesh): ## all interfaces are created equal(ly)
        ## loops over list of tuples of
        ## elements and takes decisions
        ## on how to split nodes
        return femesh


class Materials(Criteria):
    def __init__(self, materialA, materialB):
        self.materialA = materialA
        self.materialB = materialB
        Criteria.__init__(self)
    def find_interfaces(self, femesh):
        elist = []
        ##
        for element in femesh.element_iterator():
            ## first find element that matches material A or B
            ## next, check its neighbor
            ## if match, add it to the list
            pass ## for now
        return elist


registeredclass.Registration(
    'Materials',
    Criteria, ## superclass
    Materials, ## subclass
    ordering = 100,
    params = [
    materialparameter.MaterialParameter('materialA',
                                        tip='Material on side A of interface'),
    
    materialparameter.MaterialParameter('materialB',
                                        tip='Material on side B of interface')
    ],
    tip="select two materials to specify locus of interface"
    )
